static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xA8, 0xE9, 0x4C, 0xC3, 0x84, 0x6C, 0xDB, 0xAB, 0x24, 0xE7,
        0x98, 0xA8, 0xAF, 0x08, 0x75, 0x51, 0x61, 0xD2, 0xA7, 0x56,
        0xE0, 0xC1, 0x7A, 0xDE, 0x9B, 0x62, 0x9D, 0xCF, 0x28, 0x7E,
        0xD4, 0xA3, 0x68, 0xC2, 0x19, 0x71, 0xC9, 0xD4, 0x59, 0xA6,
        0x8A, 0xF5, 0x86, 0x3D, 0x39, 0x10, 0x7E, 0x8E, 0x94, 0x36,
        0xDD, 0x6C, 0xEE, 0x31, 0x85, 0xF6, 0x0C, 0xAD, 0x2F, 0x97,
        0xC7, 0x82, 0xFE, 0x67
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
